#! /bin/sh
-LC_ALL=C
-export LC_ALL
-
# Shell script to build Makefile in a build directory. It must be called
# from inside the directory. It does its own checking of when to rebuild; it
# just got too horrendous to get it right in "make", because of the optionally
# existing configuration files.
#
-# Copyright (c) The Exim Maintainers 1995 - 2020
+# Copyright (c) The Exim Maintainers 1995 - 2024
+# SPDX-License-Identifier: GPL-2.0-or-later
+
+
+LC_ALL=C
+export LC_ALL
# First off, get the OS type, and check that there is a make file for it.
sed "s/^/PKG_CONFIG_PATH='/" < ./$mftepcp2 | sed "s/\$/'/" > ./$mftepcp
. ./$mftepcp
export PKG_CONFIG_PATH
- egrep -v "^[$st]*PKG_CONFIG_PATH[$st]*=" ./$mft > ./$mftt
+ grep -E -v "^[$st]*PKG_CONFIG_PATH[$st]*=" ./$mft > ./$mftt
rm -f ./$mft
(
echo "# Collapsed PKG_CONFIG_PATH in build-prep:"
# handle pkg-config
# beware portability of extended regexps with sed.
-egrep "^[$st]*(AUTH|LOOKUP)_[A-Z0-9_]*[$st]*=[$st]*" $mft | \
+grep -E "^[$st]*(AUTH|LOOKUP)_[A-Z0-9_]*[$st]*=[$st]*" $mft | \
sed "s/[$st]*=/='/" | \
sed "s/\$/'/" > $mftt
-egrep "^[$st]*((USE_(OPENSSL|GNUTLS)_PC)|SUPPORT_TLS|USE_GNUTLS|PCRE_CONFIG|AVOID_GNUTLS_PKCS11)[$st]*=[$st]*" $mft | \
+grep -E "^[$st]*((USE_(OPENSSL|GNUTLS)_PC)|SUPPORT_TLS|USE_GNUTLS|PCRE2?_CONFIG|AVOID_GNUTLS_PKCS11)[$st]*=[$st]*" $mft | \
sed "s/[$st]*=/='/" | \
sed "s/\$/'/" >> $mftt
if test -s $mftt
PCRE_CONFIG)
case $PCRE_CONFIG in
yes|YES|y|Y)
- cflags=`pcre-config --cflags`
+ echo >&2 "pcre is no longer supported; migrate to pcre2"
+ exit 1
+
+# cflags=`pcre-config --cflags`
+# if [ $? -ne 0 ]; then
+# echo >&2 "*** Missing pcre-config for regular expression support"
+# exit 1
+# fi
+# libs=`pcre-config --libs`
+# if [ ".$cflags" != "." ]; then
+# echo "INCLUDE += $cflags"
+# fi
+# echo "PCRE_LIBS=$libs"
+ ;;
+ esac
+ ;;
+
+ PCRE2_CONFIG)
+ case $PCRE2_CONFIG in
+ yes|YES|y|Y)
+ cflags=`pcre2-config --cflags`
if [ $? -ne 0 ]; then
- echo >&2 "*** Missing pcre-config for regular expression support"
+ echo >&2 "*** Missing pcre2-config for regular expression support"
exit 1
fi
- libs=`pcre-config --libs`
+ libs=`pcre2-config --libs8`
if [ ".$cflags" != "." ]; then
echo "INCLUDE += $cflags"
fi
cp ../src/lookups/Makefile $look_mf_pre
../scripts/lookups-Makefile
+while read class classdef names
+do
+ cp ../src/$class/Makefile $class/Makefile.predynamic
+ CLASS=$class CLASSDEF=$classdef DRNAMES="$names" ../scripts/drivers-Makefile
+ mv $class/Makefile.postdynamic $class/Makefile
+ rm $class/Makefile.predynamic
+done <<-END
+ routers ROUTER ACCEPT DNSLOOKUP IPLITERAL IPLOOKUP MANUALROUTE QUERYPROGRAM REDIRECT
+ transports TRANSPORT APPENDFILE AUTOREPLY LMTP PIPE QUEUEFILE SMTP
+ auths AUTH CRAM_MD5 CYRUS_SASL DOVECOT EXTERNAL GSASL HEIMDAL_GSSAPI PLAINTEXT SPA TLS
+END
+
# See if there is a definition of EXIM_PERL in what we have built so far.
# If so, run Perl to find the default values for PERL_CC, PERL_CCOPTS,
# and PERL_LIBS. These need to be put at the top of the Makefile, so we rename